src/main/java/com/realdolmen/air/beans/AirlineSearchBean.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.flightmodel.Airline;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.ArrayList;
import java.util.List;

@RequestScoped
@Named
public class AirlineSearchBean {
    private final Logger LOGGER = LoggerFactory.getLogger(AirlineSearchBean.class);

    @PersistenceContext
    EntityManager em;

    public List<Airline> getAllAirlines(){
        try { return em.createQuery("select a from Airline a", Airline.class).getResultList(); }
        catch (Exception e){ return new ArrayList<>(); }
    }

    public Airline getAirlineByID(long airlineId) {
        try {return em.find(Airline.class, airlineId);}
        catch (Exception e){LOGGER.info("nO airport found for id" + airlineId); return null;}
    }
}

src/main/java/com/realdolmen/air/beans/AirportAutoCompleteBean.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.flightmodel.Airport;

import javax.ejb.Stateful;
import javax.faces.view.ViewScoped;
import javax.inject.Inject;
import javax.inject.Named;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Named
@Stateful
@ViewScoped
public class AirportAutoCompleteBean implements Serializable{

    @Inject
    AirportSearchBean airportSearchBean;

    private Airport foundAirport;

    private String airportResult;


    public List<String> autocompleteAirports(String autoCompleteMe) {
        List<Airport> autocompletions = this.airportSearchBean.getAllAirports();
        List<String> autocompletionsResult = new ArrayList<>();
        autoCompleteMe = autoCompleteMe.toLowerCase();

        for (Airport airport : autocompletions) {
            if (airport.getCountry().toLowerCase().contains(autoCompleteMe) ||
                    airport.getName().toLowerCase().contains(autoCompleteMe) ||
                    airport.getCode().toLowerCase().contains(autoCompleteMe)) {
                autocompletionsResult.add(airport.printDetails());

            }
        }

        return autocompletionsResult;
    }

    public Airport getFoundAirport() {
        return foundAirport;
    }

    public void setFoundAirport(Airport autoCompleteMe) {
        this.foundAirport = autoCompleteMe;
    }

    public String getAirportResult() {
        return airportResult;
    }

    public void setAirportResult(String airportResult) {
        this.airportResult = airportResult;
    }

    public AirportAutoCompleteBean setAirportSearchBean(AirportSearchBean airportSearchBean) {
        this.airportSearchBean = airportSearchBean;
        return this;
    }


}

src/main/java/com/realdolmen/air/beans/AirportBean.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.flightmodel.Airport;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.ejb.Stateful;
import javax.faces.view.ViewScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by AUABH09 on 12-Nov-18.
 */
@Named
@Stateful
@ViewScoped
public class AirportBean implements Serializable {

    @PersistenceContext
    private EntityManager em;

    final Logger logger = LoggerFactory.getLogger(AirportBean.class.getName());

    private Airport airport = new Airport();

    private boolean edit = false;


    private boolean add = false;

    public void save(){
        try{
            em.persist(this.airport);
            add = false;
            reset();
        } catch (Exception e) {
            logger.warn("could not persist new airport");
        }
        reset();
    }

    public void update() {
        edit = false;
        try {
            em.merge(airport);
            reset();
        } catch (Exception e) {
            logger.warn("could not update this airport");
        }
    }

    public void reset() {
        this.airport = new Airport();
    }

//    public Airport findAirport(String code) {
//        Query query = em.createQuery("SELECT a from Airport a where a.code = :code", Airport.class);
//        return query.getSingleResult()!= null ? airport = (Airport) query.getSingleResult() : null;
//    }

    public void editAirport(long id) {
        edit = true;
        add = false;
        Query query = em.createQuery("select a from Airport a WHERE a.id = :id",Airport.class);
        query.setParameter("id",id);
        airport = (Airport) query.getSingleResult();
    }
    public void addAirport(){
        add = true;
        edit = false;
        reset();
    }


    public List<String> getAllCountries() {
        List<String> countriesList = em.createQuery("select distinct a.country from Airport a ",String.class).getResultList();

        return countriesList;
    }

    public List<Integer> getAllTimeZones() {
        List<Integer> timeZones = new ArrayList<>();
        for (int i = -11; i < 12; i++){
            timeZones.add(i);
        }
        return timeZones;
    }

    public Airport getAirport() {
        return airport;
    }

    public void setAirport(Airport airport) {
        this.airport = airport;
    }

    public boolean isEdit() {
        return edit;
    }
    public boolean isAdd() {
        return add;
    }
}

src/main/java/com/realdolmen/air/beans/AirportSearchBean.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.flightmodel.Airport;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

@Named
@RequestScoped
public class AirportSearchBean implements Serializable {

    @PersistenceContext
    EntityManager entityManager;

//    private Airport autoCompleteMe;

    public List<Airport> getAllAirports(){
        try{return entityManager.createQuery("select a from Airport a", Airport.class).getResultList();}
        catch (Exception e) {return new ArrayList<>();}
    }

    public Airport getAirportById(long id){
        try{
            return entityManager.createQuery("select a from Airport a WHERE  a.id = ?1", Airport.class)
                    .setParameter(1, id)
                    .getSingleResult();
        } catch (Exception e){
            return null;
        }
    }

    public List<String> getAllCountries(){
        List<String> countriesList = entityManager.createQuery("select distinct a.country from Airport a ",String.class).getResultList();
        Collections.sort(countriesList);
        return countriesList;
    }

    public List<Integer> getAllTimeZones(){
        List<Integer> timeZones = new ArrayList<>();
        for (int i = -12; i <= 12; i++){
            timeZones.add(i);
        }
        return timeZones;
    }

//    public List<Airport> autocompleteAirports(String autoCompleteMe){
//        List<Airport> autocompletions = this.getAllAirports();
//        List<Airport> autocompletionsResult = new ArrayList<>();
//
//        for(Airport airport: autocompletions){
//            if (airport.getCountry().toLowerCase().contains(autoCompleteMe) ||
//                    airport.getName().toLowerCase().contains(autoCompleteMe) ||
//                    airport.getCode().toLowerCase().contains(autoCompleteMe)){
//                autocompletionsResult.add(airport);
//            }
//        }
//        return autocompletionsResult;
//    }
//
//    public Airport getAutoCompleteMe() {
//        return autoCompleteMe;
//    }
//
//    public void setAutoCompleteMe(Airport autoCompleteMe) {
//        this.autoCompleteMe = autoCompleteMe;
//    }
}

src/main/java/com/realdolmen/air/beans/CurrentUser.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.accounts.Person;
import com.realdolmen.air.util.UserRole;

import javax.ejb.Stateful;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import java.io.Serializable;

@Named
@Stateful
@SessionScoped
public class CurrentUser implements Serializable {

    private Person currentUser;

    public void setCurrentUser(Person person) {
        this.currentUser = person;
    }

    public boolean isLoggedIn() {
        return this.currentUser != null;
    }

    public UserRole getCurrentUserRole() {
        if (this.isLoggedIn()) {

            return this.currentUser.getRole();
        }
        return UserRole.PARTNER;
    }

    public long getCurrentUserId() {
        if (this.isLoggedIn()) {
            return this.currentUser.getId();
        }
        return 0;
    }

    public long setCurrentByUserId() {
        if (this.isLoggedIn()) {
            return this.currentUser.getId();
        }
        return 0;
    }

    public Person getCurrentUser() {
        return currentUser;
    }
}

src/main/java/com/realdolmen/air/beans/FlightSearchBean.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.flightmodel.FlightInstance;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import java.util.List;

@Named
@RequestScoped
public class FlightSearchBean {

    @PersistenceContext
    EntityManager entityManager;

    public List<FlightInstance> getAllFlights() {
        Query q = this.entityManager.createQuery("select f from FlightInstance f", FlightInstance.class);
        return q.getResultList();
    }

    public FlightInstance getFlightById(long id) {
        return this.entityManager.find(FlightInstance.class, id);
    }
}

src/main/java/com/realdolmen/air/beans/LanguageSwitcher.java
package com.realdolmen.air.beans;


import javax.enterprise.context.SessionScoped;
import javax.faces.context.FacesContext;
import javax.inject.Named;
import java.io.Serializable;
import java.util.Locale;

@Named
@SessionScoped
public class LanguageSwitcher implements Serializable {

    private Locale locale = FacesContext.getCurrentInstance().getViewRoot().getLocale();

    public Locale getLocale() {
        return locale;
    }

    public String getLanguage() {
        return locale.getLanguage();
    }

    public void changeLanguage(String language) {
        locale = new Locale(language);
        FacesContext.getCurrentInstance().getViewRoot().setLocale(locale);
    }

}

src/main/java/com/realdolmen/air/beans/Main.java
package com.realdolmen.air.beans;

import com.realdolmen.air.datamodel.accounts.Person;
import com.realdolmen.air.exceptions.InvalidPasswordException;
import com.realdolmen.air.exceptions.InvalidStringArgException;
import com.realdolmen.air.services.LoginService;
import com.realdolmen.air.util.UserRole;

import javax.annotation.PostConstruct;
import javax.ejb.Stateful;
import javax.faces.bean.ApplicationScoped;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.io.Serializable;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Random;
import java.util.logging.Logger;

@Named
@Stateful
@ApplicationScoped
//@Singleton
public class Main implements Serializable {

    @PersistenceContext
    private EntityManager em;
    private Logger LOGGER = Logger.getLogger(LoginService.class.getName());
    private boolean madeUsers = false;

    private byte[] makeHashPassword(String passstring) {
        byte[] password = null;
        try {
            password = MessageDigest.getInstance("SHA-256").digest(passstring.getBytes());
        } catch (NoSuchAlgorithmException e) {
            e.printStackTrace();
        }
        return password;
    }

    private Person makePerson(String username, String first, String lastname, String passstring, UserRole role) throws Exception, InvalidStringArgException, InvalidPasswordException {
        Person person = new Person();
        Random r = new Random();
        int RandomInt = r.nextInt(1000);
        String randomIntString = Integer.toString(RandomInt);
        username = username + randomIntString;
        String email = first + randomIntString +"@hotmail.com";
        person.setEmail(email);
        person.setFirstName(first);
        person.setLastName(lastname);
        person.setUserName(username);
        byte[] password = makeHashPassword(passstring);
        person.setPassword(password);
        person.setRole(role);
        return person;
    }
    @PostConstruct
    public void setupPersons() throws Exception, InvalidStringArgException, InvalidPasswordException {
        try {


            if (!madeUsers) {
                Person traveller = makePerson("leeroy", "Leeroy", "Jenkins", "123", UserRole.CUSTOMER);
                Person worker = makePerson("bob","bob","debouwer","123",UserRole.EMPLOYEE);
                Person airline = makePerson("ryanair","ryanair","ryanair","123",UserRole.PARTNER);
                em.persist(traveller);
                em.persist(worker);
                em.persist(airline);
                LOGGER.warning("Person has been persisted");
                toggleMadeUsers();
            }
        } catch (Exception  e){

        }

    }

    private void toggleMadeUsers(){
        this.madeUsers = true;
    }

}

src/main/java/com/realdolmen/air/services/DateBean.java
package com.realdolmen.air.services;

import javax.enterprise.context.RequestScoped;
import javax.inject.Named;
import java.io.Serializable;
import java.time.LocalDate;

/**
 * Created by KPRBL94 on 13/11/2018.
 */

@Named
@RequestScoped
public class DateBean implements Serializable {

    public LocalDate today(){
      return  LocalDate.now();
    }
}

src/main/java/com/realdolmen/air/services/SearchResultBean.java
package com.realdolmen.air.services;

import com.realdolmen.air.datamodel.LuxuryWithCapacityAndPrices;
import com.realdolmen.air.datamodel.flightmodel.FlightInstance;

import javax.ejb.Stateful;
import javax.enterprise.context.SessionScoped;
import javax.inject.Named;
import java.io.Serializable;
import java.util.List;


@SessionScoped
@Stateful
@Named
public class SearchResultBean implements Serializable {

    private List<FlightInstance> singleSearchResults;
    private List<FlightInstance> returnSearchResults;
    private boolean isToggled;
    private Integer numberOfSeatsRequested = 1;

    private FlightInstance chosenFlight;


    public FlightInstance getChosenFlight() {
        return chosenFlight;
    }

    public void setChosenFlight(FlightInstance chosenFlight) {
        this.chosenFlight = chosenFlight;

    }

    public List<FlightInstance> getReturnSearchResults() {
        return returnSearchResults;
    }

    public void setReturnSearchResults(List<FlightInstance> returnSearchResults) {
        this.returnSearchResults = returnSearchResults;

    }


    public List<FlightInstance> getSingleSearchResults() {
        return singleSearchResults;
    }

    public void setSingleSearchResults(List<FlightInstance> singleSearchResults) {
        this.singleSearchResults = singleSearchResults;
    }


    public String getDisplayPrices(FlightInstance flightInstance) {
        String returnString = "";

        for (int i = 0; i< flightInstance.getLuxuryCapacitiesAndPrices().size(); i++) {
            returnString += flightInstance.getLuxuryCapacitiesAndPrices().get(i).getLuxuryFlightQuality().toString() + " " + flightInstance.getLuxuryCapacitiesAndPrices().get(i).getAskingPrice();
            if((i+1 <flightInstance.getLuxuryCapacitiesAndPrices().size())) {
                returnString+= "\n";
            }
        }
        return returnString;
    }



    public String getDisplayDiscounts(FlightInstance flightInstance) {
        String returnString = "";

        for (int i = 0; i< flightInstance.getVolumeDiscounts().size(); i++) {
            returnString += "for " + flightInstance.getVolumeDiscounts().get(i).getNbOfSeatForThisDicscount() + ": " + flightInstance.getVolumeDiscounts().get(i).getPurcentage() + "%";
            if((i+1 <flightInstance.getVolumeDiscounts().size())) {
                returnString+= "\n";
            }
        }
        return returnString;
    }

    public Integer getNumberOfSeatsRequested() {
        return numberOfSeatsRequested;
    }

    public SearchResultBean setNumberOfSeatsRequested(Integer numberOfSeatsRequested) {
        this.numberOfSeatsRequested = numberOfSeatsRequested;
        return this;
    }

    public String reserve(FlightInstance flight){
        this.chosenFlight = new FlightInstance();
        this.chosenFlight = flight;
        return "flightdetails.xhtml?faces-redirect=true";
    }
}

src/main/webapp/FlightCRUD.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:b="http://bootsfaces.net/ui"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
>

<ui:composition template="WEB-INF/compatible-template.xhtml">
    <ui:define name="pageContent">

        <b:container>
            <div class="formPanel customRows2">

                <b:form>
                    <b:commandButton value="Add flight" look="success" icon="edit" styleClass="editButtonClass"
                                     size="lg" action="#{flightCreationBean.viewAddFlight()}"
                                     rendered="#{currentUser.currentUserRole == 'PARTNER'}"/>
                </b:form>
                <br/>

                <b:dataTable value="#{flightCreationBean.getAllFlights()}" var="flight">

                    <b:dataTableColumn>
                        <f:facet name="header">Route</f:facet>
                        <h:outputText value="#{flight.getFlightRoute().toString()}"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Departure</f:facet>
                        <h:outputText value="#{flight.getDepartureLocalDateTime()}"
                                      converter="realdolmen.dateTimeConverter"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Arrival</f:facet>
                        <h:outputText value="#{flight.getArrivalLocalDateTime()}"
                                      converter="realdolmen.dateTimeConverter"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Airline</f:facet>
                        <h:outputText value="#{flight.getAirline().getName()}"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header"> Luxury settings </f:facet>
                        <h:form>
                            <b:commandButton value="Details" look="info" size="sm"
                                             action="#{flightCreationBean.viewLuxuryDetails(flight.id)}"/>
                        </h:form>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header"> Volume Discounts </f:facet>
                        <h:form>
                            <b:commandButton value="Details" look="info" size="sm"
                                             action="#{flightCreationBean.viewDiscountDetails(flight.id)}"/>
                        </h:form>
                    </b:dataTableColumn>

                    <b:dataTableColumn rendered="#{currentUser.currentUserRole == 'PARTNER'}">
                        <f:facet name="header"> Edit </f:facet>
                        <h:form>
                            <b:commandButton value="Edit" icon="edit" size="sm"
                                             action="#{flightCreationBean.viewEditFlight()}"/>
                        </h:form>
                    </b:dataTableColumn>
                </b:dataTable>


                <!--scripting 4 popups-->

                <script type="text/javascript">
                    $(function () {
                        if ("#{flightCreationBean.edit}" != "false") $('#editFlightPopup').modal();
                        if ("#{flightCreationBean.add}" != "false") $('#addFlightPopup').modal();
                        if ("#{flightCreationBean.detailsLuxury}" != "false") $('#detailsLuxuryPopup').modal();
                        if ("#{flightCreationBean.detailsDiscounts}" != "false") $('#detailsDiscountPopup').modal();
                    });
                </script>

            </div>
        </b:container>

        <!--flight adding popup-->

        <b:modal id="addFlightPopup" title="Add Flight"
                 styleClass="responsiveModalPseudoClass">
            <b:form id="addFlight">
                    <b:column span="6">
                        <b:dateTimePicker value="#{flightCreationBean.flight.departureLocalDateTime}"
                                          converter="realdolmen.dateTimeConverter"
                                          format="DD/MM/YYYY HH:mm"
                                          label="Departure date/time"
                                          minDate="#{dateBean.today()}"
                                          required="true"/>
                        <b:inputText value="#{routeSearchBean.from}" update="selectRoute"
                                     label="From (airport code/name/country)"/>
                    </b:column>
                    <b:column span="6">
                        <b:dateTimePicker value="#{flightCreationBean.flight.departureLocalDateTime}"
                                          converter="realdolmen.dateTimeConverter"
                                          format="DD/MM/YYYY HH:mm"
                                          label="Arrival date/time"
                                          minDate="#{dateBean.today()}"
                                          required="true"/>
                        <b:inputText value="#{routeSearchBean.to}" update="selectRoute"
                                     label="To (airport code/name/country)"/>
                    </b:column>
                    <b:column span="12">
                        <b:selectOneMenu id="selectRoute" value="#{flightCreationBean.flight.flightRoute}"
                                         ajax="true"
                                         process="@this"
                                         label="Selecht route based on origin and destination" required="true">
                            <f:selectItems value="#{routeSearchBean.getRoutesBySetStringParams()}" var="route"
                                           itemValue="#{route}" itemLabel="#{route.toString()}"/>
                        </b:selectOneMenu>
                    </b:column>

                    <b:column span="6">
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices.numberOfSeats}"
                                     placeholder="Capacity" label="Economy"
                                     required="true"/>
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices.askingPrice}"
                                     placeholder="Base price"
                                     required="true"/>
                        <b:column span="6">
                            <b:inputText value="#{flightCreationBean.volumeDiscount.nbOfSeatForThisDicscount}"
                                         placeholder="Nb. seats"
                                         label="Volume discount 1"/>
                            <b:inputText value="#{flightCreationBean.volumeDiscount.purcentage}"
                                         placeholder="Discount"
                            />

                        </b:column>
                        <b:column span="6">
                            <b:inputText value="#{flightCreationBean.volumeDiscount2.nbOfSeatForThisDicscount}"
                                         placeholder="Nb. of seats"
                                         label="Volume discount 2"/>
                            <b:inputText value="#{flightCreationBean.volumeDiscount2.purcentage}"
                                         placeholder="Discount"
                            />
                        </b:column>

                    </b:column>
                    <b:column span="6">
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices1.numberOfSeats}"
                                     placeholder="Capacity" label="First class"/>
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices1.askingPrice}"
                                     placeholder="Base price"/>
                        <b:selectBooleanCheckbox value="#{flightCreationBean.repeat}" caption="Repeat daily"
                                                 label="Schedule flight"/>
                        <b:selectBooleanCheckbox value="#{flightCreationBean.repeatweekly}" caption="Repeat weekly"/>
                        <b:dateTimePicker value="#{flightCreationBean.repeatTill}"
                                          converter="realdolmen.dateConverter"
                                          format="DD/MM/YYYY"
                                          minDate="#{dateBean.today()}"/>
                    </b:column>

                    <b:column span="12">
                        <h:outputText val=""/>
                    </b:column>
                <div class="modal-footer">

                    <b:button value="Close" dismiss="modal" style="float:left;"/>


                    <b:commandButton style="float:right;" value="Create" look="primary" dismiss="modal"
                                     action="#{flightCreationBean.createFlight()}"/>
                </div>
            </b:form>

        </b:modal>

        <!--edit flight popup-->

        <b:modal id="editFlightPopup" title="Edit flight information" styleClass="modalPseudoClass">
            <b:form id="editFlight">

            </b:form>
        </b:modal>

        <!--details luxury popup-->

        <b:modal id="detailsLuxuryPopup" title="Luxury class details" styleClass="responsiveModalPseudoClass">
            <h:form id="editLuxury">
                <b:dataTable value="#{flightCreationBean.searchLuxuryDetails()}" var="detail"
                             class="luxTabClass"
                             responsive="true" scroll-horizontally="true">
                    <b:dataTableColumn label="Luxury class" value="#{detail.flightQuality}"/>
                    <b:dataTableColumn label="Remaining seats" value="#{detail.numberOfSeats}"/>
                    <b:dataTableColumn label="Base price" value="#{detail.basePrice}"/>
                    <b:dataTableColumn label="Asking price" value="#{detail.askingPrice}">
                        <h:outputText value="#{detail.askingPrice}"
                                      rendered="#{flightCreationBean.editLuxury}"/>

                    </b:dataTableColumn>
                    <b:dataTableColumn label="Edit" rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}">
                        <h:inputText binding="#{floatValue}" placeholder="#{detail.askingPrice}"/>
                        <b:commandButton icon="edit" value="Update asking price" look="info" update="@form"
                                         onclick="ajax:flightCreationBean.updateLuxuryClass(detail.id,floatValue.value)"
                        />
                    </b:dataTableColumn>
                </b:dataTable>
                <b:button value="Close" dismiss="modal"/>
            </h:form>
        </b:modal>

        <!--Discount popup-->

        <b:modal id="detailsDiscountPopup" title="Volume discount details"
                 styleClass="responsiveModalPseudoClass">
            <b:form id="editDiscount">
                <b:commandButton value=" Add/Update" look="success" icon="edit" size="sm"
                                 style="margin-bottom:1em"
                                 rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}"
                />
                <br/>
                <b:dataTable value="#{flightCreationBean.searchDiscountDetails()}" var="discount"
                             widgetVar="tableWidgetVar" responsive="true" scroll-horizontally="true">
                    <b:dataTableColumn label="Required nb. of seats">
                        <h:outputText value="#{discount.nbOfSeatForThisDicscount}"/>
                    </b:dataTableColumn>
                    <b:dataTableColumn label="Discount">
                        <h:outputText value="#{discount.purcentage*100} \%"/>
                    </b:dataTableColumn>
                    <b:dataTableColumn label="Delete" rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}">
                        <b:commandButton value="Delete" look="danger" id="delDisc"
                                         action="#{flightCreationBean.deleteDiscount(discount)}"/>
                    </b:dataTableColumn>
                </b:dataTable>
            </b:form>
        </b:modal>

    </ui:define>
</ui:composition>

<style type="text/css">
    .editButtonClass {
        margin-bottom: 1em
    }

</style>

</html>

src/main/webapp/ThankYou.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
>
<head>
    <link rel="stylesheet" type="text/css" href="styles/style.css"/>
    <title>Thank you !</title>
</head>
<body>
<h1>Thank you !</h1>


</body>
</html>

src/main/webapp/add.xhtml
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:b="http://bootsfaces.net/ui"
>

<ui:composition template="WEB-INF/template.xhtml">
    <ui:define name="pageContent">

        <!-- Add airport popup -->
           <b:form id="addAirport">
                <b:panelGrid columns="2">

                    <h:outputLabel>Airport code:</h:outputLabel>
                    <b:inputText value="#{airportBean.airport.id}" />

                    <h:outputLabel>Airport name:</h:outputLabel>
                    <b:inputText value="#{airportBean.airport.name}" />

                    <h:outputLabel>Airport country:</h:outputLabel>
                    <b:inputText value="#{airportBean.airport.country}"/>


                    <h:outputLabel>Airport timezone:</h:outputLabel>
                    <b:inputText value="#{airportBean.airport.timeZone}"/>
                </b:panelGrid>
                <b:button value="ok" look="primary" action="#{airportBean.save()}"/>
               <!-- TODO SET PARAMS-->
                <b:button value="WTFOKOKOKOKOKOK" look="primary" action="#{airportBean.save()}"/>
            </b:form>
    </ui:define>
</ui:composition>
<style type="text/css">

</style>

</html>